//Last modified 3/30/8
//*****************************************************************************************
//Description: This is called when the mission starts & begins game execution on server & clients.
//*****************************************************************************************

OnPlayerConnected "[_name] Exec ""Server\Server_PlayerConnected.sqs""";
OnPlayerDisconnected "[_name] Exec ""Server\Server_PlayerDisconnected.sqs""";

EnableTeamSwitch false;
{RemoveSwitchableUnit _x} ForEach SwitchableUnits;

//Starting parameters.
fastTime = false;
easierAI = false;
nightMission = false;
noGrass = false;
noFastTravel = false;
enableArtillery = true;

//Setting true can make game last longer (AIs won't attack bases when all players are absent from game).
longerPersistentServerGame = false;

_options = param1;

if (_options >= 8) then {enableArtillery = false;_options = _options - 8};
if (_options >= 4) then {fastTime = true;_options = _options - 4};
if (_options >= 2) then {noGrass = true;_options = _options - 2};
if (_options >= 1) then {nightMission = true;_options = _options - 1};

if (noGrass) then {SetTerrainGrid 50};
if (nightMission && daytime > 3 && daytime < 20) then {SkipTime 12};

destroyBase = true;
minutesLeft = -1;
scoreToWin = -1;

if (param2 == 1) then {destroyBase = false};
if (param2 == 2) then {minutesLeft = 30};
if (param2 == 3) then {minutesLeft = 60};
if (param2 == 4) then {minutesLeft = 90};

if (param2 == 5) then {scoreToWin = 100};
if (param2 == 6) then {scoreToWin = 200};
if (param2 == 7) then {scoreToWin = 500};
if (param2 == 8) then {scoreToWin = 1000};

timeGameOver = -1;
if (minutesLeft != -1) then {timeGameOver = time + minutesLeft * 60};

gameStarted = false;
gameInitialized = false;
commonInitComplete = false;
commonFunctionsCompiled = false;

VOTETIME = 60;

//Advanced squads
eastTeams = [Group EastSlot1,Group EastSlot2,Group EastSlot3,Group EastSlot4,Group EastSlot5,Group EastSlot6,Group EastSlot7,Group EastSlot8];
westTeams = [Group WestSlot1,Group WestSlot2,Group WestSlot3,Group WestSlot4,Group WestSlot5,Group WestSlot6,Group WestSlot7,Group WestSlot8];

//Advanced squads
eastSlots = [vehicleVarName EastSlot1,vehicleVarName EastSlot2,vehicleVarName EastSlot3,vehicleVarName EastSlot4,vehicleVarName EastSlot5,vehicleVarName EastSlot6,vehicleVarName EastSlot7,vehicleVarName EastSlot8];
westSlots = [vehicleVarName WestSlot1,vehicleVarName WestSlot2,vehicleVarName WestSlot3,vehicleVarName WestSlot4,vehicleVarName WestSlot5,vehicleVarName WestSlot6,vehicleVarName WestSlot7,vehicleVarName WestSlot8];

_count = 1;
{Call Compile Format["EastTeam%1 = _x",_count];_count = _count + 1} ForEach eastTeams;
_count = 1;
{Call Compile Format["WestTeam%1 = _x",_count];_count = _count + 1} ForEach westTeams;

maxPlayers = Count eastTeams;

//Run any init code common to server and clients.
[] ExecVM "Common\Init\Init_Common.sqf";

if (IsServer) then {[] Exec "Server\Init\Init_Server.sqs"};

"EastTempRespawnMarker" SetMarkerTypeLocal "Empty";
"WestTempRespawnMarker" SetMarkerTypeLocal "Empty";

WaitUntil {commonInitComplete};

if (Local player) then {[] Exec "Client\Init\Init_Client.sqs"};

//*****************************************************************************************
//1/17/7 MM - Created file.
